/* @(#)pop3_var.h, pop3
 * $Id: pop3_var.h,v 1.2 1996/07/09 17:55:46 jerry Rel $
 * Copyright (c) 1994/95/96 jerry g geiger
 * All rights reserved.
 *
 * constants, variables and structures
 *	
 */
 
/* Server responses & code values	*/
	/* positive success indicator "+OK" */
#define PSI 1
	/*   negative success indicator "-ERR" */
#define NSI 2
	/* no command, undefined, no reply	*/
#define NCMD 0
	/* command failure/aborted	*/
#define BCMD -1
	/* lost peer return value	*/
#define LSP	-2
	/* message received/processed	*/
#define BADREC	4
#define BADSTORE 8
#define SUCCREC 0x10
#define DELIVERBAD 0x20
#define DELIVERED 0x40

/*
 * pop3 global variables.
 */
#ifndef _mainPOP3
extern	char *myname;
extern	char Version[];		/* version string	*/
extern	char tzstring[];	/* TimeZone string according RFCxxx	*/
extern	char *the_user;		/* the username */
extern	char *the_host;		/* the local host-name */
extern	char spooldir[];	/* pop3's spooldir see pathnames.h	*/
extern	char id_prefix[];	/* msg-id prefix-string (->check_path)	*/
extern	struct servent *sp;
extern	char logfile[];
extern	int ip_conn_timeout; /* timeout value in seconds for connect() */
#endif
#ifndef _pop3POP3
extern int abrtflag;
extern char *r_user;
extern char *apop_id;
extern long reply_dig[2];
extern char *reply_tok;
#endif


/*
 * Options and other state info.
 */
int	verbose;		/* print messages coming back from server */
int	connected;		/* connected to server */
int	fromatty;		/* input is from a terminal */
int	interactive;		/* interactively prompt on m* cmds */
int	debug;			/* debugging level */
int	bell;			/* ring bell on cmd completion */
int	autologin;		/* establish user account on connection */
int	code;			/* return/reply code for pop3 command */
int autodeliver;
int keepbadmsgs;
int getmails4host;

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

#ifndef MAXDOMAINNAMELEN
#define MAXDOMAINNAMELEN 255
#endif

char	*hostname;		/* name of host connected to */

jmp_buf	toplevel;		/* non-local goto stuff for cmd scanner */

char	line[200];		/* input line buffer */
char	*stringbase;		/* current scan point in line buffer */
char	argbuf[200];		/* argument storage buffer */
char	*argbase;		/* current storage point in arg buffer */
char	*altarg;
int		margc;			/* count of arguments on input line */
char	*margv[20];		/* args parsed from input line */

int	options;		/* used during socket creation */

/*
 * Format of command table.
 */
struct cmd {
	char	*c_name;	/* name of command */
	char	**c_help;	/* help strings */
	char	c_bell;		/* give bell when command completes */
	char	c_conn;		/* pop3 must be in state >= c_conn to use command */
	char	c_mstate;	/* pop3 must be in state <= c_mstate to use command */
/* defines for connected, .c_conn, .c_mstate */
#define CONNECTED 1
#define	AUTHORI	1
#define TRANSACT 2
	/* connected can't reach these values:	*/
#define ISLOCKED 5
#define NOTIMPL	6
	int	(*c_handler)();	/* function to call */
};


typedef struct Msglist {
	 struct Msglist * next;
	 int	code;
	 char	*id; 	/* our msg-id == filename of spool file */
	 char	*from;
	 char	*to;
	 char	*uidl;	/* uidl received from server  */
} MSGLIST;

extern MSGLIST *recmsgs;


	/* log defines	*/

#define	LOGCONNECTED 1
#define	LOGDISSCON	 2
#define	LOGRECEIVED  3
#define	LOGDELIVER	 4
#define	LOGLOSTPEER  5
#define	LOGFATAL 	 6
#define	LOGLOGFAIL 	 7

/* eof pop3_var.h */
