/* @(#)poprc.c, pop3
 * $Id: pop3rc.c,v 1.2 1996/07/09 17:56:00 jerry Rel $
 * Copyright (c) 1994/95/96 jerry g geiger
 * All rights reserved.
 * based on ruserpass.c 5.1 (Berkeley) 3/1/89
 * a bit modified by jerry g geiger for usage with pop3 !
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms.
 * This program my not be sold in any way!
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

/* ruserpass.c 5.1 (Berkeley) 3/1/89
 *
 * Copyright (c) 1985 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */


#define _pop3rc
#include "pop3.h"

static	FILE *cfile;


#define	DEFAULT	1
#define	LOGIN	2
#define	USER	3
#define	PASSWD	4
#define	ID		10
#define	MACH	11

static char tokval[100];
static token();

static struct toktab {
	char *tokstr;
	int tval;
} toktab[]= {
	"default",	DEFAULT,
	"mailserver",	DEFAULT,
	"login",	LOGIN,
	"apop",		LOGIN,
	"name",		USER,
	"user",		USER,
	"password",	PASSWD,
	"passwd",	PASSWD,
	"machine",	MACH,
	0,		0
};

mruserpass(host, auser, apass, aname, aacct)
	char *host, **auser, **apass, **aname, **aacct;
{
	char *hdir, buf[BUFSIZ], *tmp;
	char myname[MAXHOSTNAMELEN], *mydomain;
	int t, i, c, usedefault = 0;
	struct stat stb;

		hdir = getenv("HOME");
		if (hdir == NULL)
			hdir = ".";
		(void) sprintf(buf, "%s/.poprc", hdir);


	if ((cfile = fopen(buf, "rt")) == NULL) {
		if (errno != ENOENT)
			myerror(buf, errno);
		return(0);
	}
	if (gethostname(myname, sizeof(myname)) < 0)
		myname[0] = '\0';
	if ((mydomain = index(myname, '.')) == NULL)
		mydomain = "";
next:
	while ((t = token())) switch(t) {

	case DEFAULT:
		if (( t = token()) != ID)
			continue;
		if(!*host) {
			usedefault = 1;
			strcpy(host, tokval);
		}
		/* FALL THROUGH */

	case MACH:
		if (!usedefault) {
			if ( t!= ID )	/* it is, after falling through from DEFAULT */
				if (token() != ID)
					continue;
			/*
			 * Allow match either for user's input host name
			 * or official hostname.  Also allow match of 
			 * incompletely-specified host in local domain.
			 */
			if (strcasecmp(host, tokval) == 0)
				goto match;
			if (strcasecmp(hostname, tokval) == 0)
				goto match;
			if ((tmp = index(hostname, '.')) != NULL &&
			    strcasecmp(tmp, mydomain) == 0 &&
			    strncasecmp(hostname, tokval, tmp-hostname) == 0 &&
			    tokval[tmp - hostname] == '\0')
				goto match;
			if ((tmp = index(host, '.')) != NULL &&
			    strcasecmp(tmp, mydomain) == 0 &&
			    strncasecmp(host, tokval, tmp - host) == 0 &&
			    tokval[tmp - host] == '\0')
				goto match;
			continue;
		}
	match:
		while ((t = token()) && t != MACH && t != DEFAULT) {
	again:
		switch(t) {
		case USER:
			if (token())
				if (*auser == 0) { 
					*auser = malloc((unsigned) strlen(tokval) + 1);
					(void) strcpy(*auser, tokval);
				} else {
					if (strcmp(*auser, tokval))
						goto next;
				}
/*
			if(t != ID)  : needs a if( (t = token()) == ID)
				goto again;
 */
			break;
		case PASSWD:
			if (
			    fstat(fileno(cfile), &stb) >= 0 &&
			    (stb.st_mode & 077) != 0) {
				myerror("Error - .poprc file not correct mode.\n"
						"Remove password or correct mode.",0);
				goto bad;
			}
			if (token() && *apass == 0) {
				*apass = malloc((unsigned) strlen(tokval) + 1);
				(void) strcpy(*apass, tokval);
			}
			break;
		case LOGIN:
			if (fstat(fileno(cfile), &stb) >= 0
			    && (stb.st_mode & 077) != 0) {
				myerror("Error - .poprc file not correct mode.\n"
						"Remove account or correct mode.",0);
				goto bad;
			}
			if (token()) {
				if(*aname == 0) { 
					*aname = malloc((unsigned) strlen(tokval) + 1);
					(void) strcpy(*aname, tokval);
				} else {
					if( (t = token()) == ID)
						goto next;
					else
						goto again;
				}
				if ((t = token()) == ID && *aacct == 0) {
					*aacct = malloc((unsigned) strlen(tokval) + 1);
					(void) strcpy(*aacct, tokval);
				}
				if(t != ID)
					goto again;
			}
			break;
		default:
			fprintf(stderr, "Unknown or misplaced .poprc keyword %s\n", tokval);
			break;
		}
		}
		goto done;
	}
done:
	(void) fclose(cfile);
	return(0);
bad:
	(void) fclose(cfile);
	return(-1);
}

static
token()
{
	char *cp;
	int c;
	struct toktab *t;

	if (feof(cfile))
		return (0);
	while ((c = getc(cfile)) != EOF &&
	    (c == '\n' || c == '\t' || c == ' ' || c == ','))
		continue;
	if (c == EOF)
		return (0);
	cp = tokval;
	if (c == '"') {
		while ((c = getc(cfile)) != EOF && c != '"') {
			if (c == '\\')
				c = getc(cfile);
			*cp++ = c;
		}
	} else {
		*cp++ = c;
		while ((c = getc(cfile)) != EOF
		    && c != '\n' && c != '\t' && c != ' ' && c != ',') {
			if (c == '\\')
				c = getc(cfile);
			*cp++ = c;
		}
	}
	*cp = 0;
	if (tokval[0] == 0)
		return (0);
	for (t = toktab; t->tokstr; t++)
		if (!strcmp(t->tokstr, tokval))
			return (t->tval);
	return (ID);
}
